routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\TagsController;
use App\Http\Controllers\CategoriesController;
use App\Http\Controllers\CommentsController;
use App\Http\Controllers\FrontendController;
use App\Http\Controllers\PostsController;
use App\Http\Controllers\UsersController;




Route::prefix('admin')->middleware(['auth'])->group(function () {
    Route::get('/dashboard', function () {
        return view('admin-panel.dashboard');
    })->name('dashboard');
    Route::put('/users/{user}/make-admin',[UsersController::class,'makeAdmin'])->name('users.makeAdmin');
    Route::put('/users/{user}/revoke-admin',[UsersController::class,'revokeAdmin'])->name('users.revokeAdmin');
    Route::resource('users', UsersController::class);
    Route::resource('tags', TagsController::class)->except(['show']);
    Route::resource('categories', CategoriesController::class)->except(['show']);

    Route::get('/posts/trashed',[PostsController::class,'trashed'])->name('posts.trashed');




    Route::resource('posts', PostsController::class);
    Route::put('posts/{post}/publish-now',[PostsController::class,'publish'])->name('posts.publish');

    Route::put('posts/trashed/{post}/restore',[PostsController::class,'restore'])->name('posts.restore');
    Route::delete('posts/trashed/{post}/destroy',[PostsController::class,'forceDelete'])->name('posts.forceDelete');

});
Route::get('/',[FrontendController::class,'index']);
Route::resource('comments', CommentsController::class);

Route::get('/categories/{category}',[FrontendController::class,'category'])->name('blogs.category');
Route::get('/tags/{tag}',[FrontendController::class,'tag'])->name('blogs.tag');
Route::get('/blogs/{post}',[FrontendController::class,'show'])->name('blogs.show');





// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('/dashboard', function () {
    return view('admin-panel.dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__.'/auth.php';

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;
    protected $guarded = [];

    public function posts()
    {
        return $this->hasMany(Post::class);
    }
}

app/Http/Controllers/CategoriesController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use Illuminate\Http\Request;
use App\Http\Requests\CreateCategoryRequest;

class CategoriesController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {   $categories = Category::latest()->paginate(5);
        return view('admin-panel.categories.index',compact('categories'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('admin-panel.categories.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CreateCategoryRequest $request)
    {
        Category::create($request->all());
        return redirect(route('categories.index'))->with('success','Category created successfully');
    }

    /**
     * Display the specified resource.
     */
    public function show(Category $category)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Category $category)
    {
        return view('admin-panel.categories.edit',compact('category'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Category $category)
    {
        $category->name = $request->name;

        if($category->isClean()){
             return redirect(route('categories.index'))->with('error','No changes made');
        }
        $category->save();
        // Tag::update($request->except(['id']));
        return redirect(route('categories.index'))->with('success','Category Updated Successfully');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Category $category)
    {
        $category->delete();
        return redirect(route('categories.index'))->with('success','Category deleted successfully');
    }
}

resources/views/admin-panel/categories/create.blade.php
@extends('admin-panel.layouts.admin')

@section('admin-content')
<div class="container-fluid my-3 px-3" >
    <div class="card-header">
        <h2>Add Category</h2>
    </div>
    <form action="{{route('categories.store')}}" method="POST">
        @csrf
        <div class="form-group">
          <label for="name">Category Name</label>
          <input name="name" type="text" class="form-control" id="name" aria-describedby="nameHelp" placeholder="Enter Category name" value="{{old('name')}}">
          <small id="nameHelp" class="form-text text-danger"> @error('name') {{ $message }} @enderror </small>
        </div>
        <button type="submit" class="btn btn-primary my-2">Submit</button>
    </form>
</div>
@endsection

resources/views/admin-panel/categories/edit.blade.php
@extends('admin-panel.layouts.admin')

@section('admin-content')
<div class="container-fluid my-3 px-3" >
    <form action="{{route('categories.update',$category->id)}}" method="POST">
        @method('PUT')
        @csrf
        <div class="form-group">
          <label for="name">Category Name</label>
          {{-- {{dd(old('name',$category->name))}} --}}
          <input name="name" type="text" class="form-control" id="name" aria-describedby="nameHelp" placeholder="Enter Catgory name" value="{{old('name',$category->name)}}">
          <small id="nameHelp" class="form-text text-danger"> @error('name') {{ $message }} @enderror </small>
        </div>
        <button type="submit" class="btn btn-primary my-2">Submit</button>
    </form>
</div>
@endsection

resources/views/admin-panel/categories/index.blade.php
@extends('admin-panel.layouts.admin')

@section('admin-content')

    <div class="container-fluid px-4 mt-4">
        <div class="row">
            <div class="col-md-12">
                <div class="card mb-4">
                    <div class="card-header">
                        <div class="d-flex justify-content-between">
                            <div>
                                <svg class="svg-inline--fa fa-table me-1" aria-hidden="true" focusable="false" data-prefix="fas" data-icon="table" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" data-fa-i2svg=""><path fill="currentColor" d="M64 256V160H224v96H64zm0 64H224v96H64V320zm224 96V320H448v96H288zM448 256H288V160H448v96zM64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H448c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64z"></path></svg>
                                <h1 class="mt-4 d-inline">Catgories</h1>
                            </div>
                            <a href="{{route('categories.create')}}" class="btn btn-outline-primary">Add Category</a>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="datatable-wrapper datatable-loading no-footer sortable searchable fixed-columns">
                            <div class="datatable-container">
                                <table id="datatablesSimple" class="datatable-table">
                                    <thead>
                                        <tr>
                                            <th>#</th>
                                            <th>Name</th>
                                            <th>Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($categories as $category )
                                        <tr >
                                            <td>{{$category->id}}</td>
                                            <td>{{$category->name}}</td>
                                            <td><a href="{{route('categories.edit',$category->id)}}" class="btn btn-warning"> <i class="fa-solid fa-pen"></i></a>
                                                <button data-category-id="{{$category->id}}" class="delete-category btn btn-danger"><i class="fa-solid fa-trash"></i></button>
                                            </td>
                                        </tr>
                                        @endforeach
                                    </tbody>
                                </table>
                            </div>
                            <div class="datatable-bottom">
                                {{$categories->links()}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{{-- Delete Modal --}}
<div class="modal fade" id="deleteModal" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Delete Category?</h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
          </button>
        </div>
        <div class="modal-body">
          Are you sure you want to delete this Category?
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          <form action="" class="d-inline-block" id="deleteForm" method="POST">
            @csrf
            @method('delete')
            <button type="submit" class="btn btn-primary">Delete Category</button>
          </form>
        </div>
      </div>
    </div>
  </div>
<script>
    const deleteBtn = document.querySelectorAll('.delete-category');
    deleteBtn.forEach((btn)=> btn.addEventListener('click', deleteCategory));
    function deleteCategory() {
        const categoryId = this.dataset.categoryId;
        const route = `/categories/${categoryId}`;
        const deleteForm = document.querySelector('#deleteForm');
        deleteForm.setAttribute('action', route);
        const deleteModal = new bootstrap.Modal('#deleteModal');
        deleteModal.show();
        // console.log("Delete Pressed!!");
    }
</script>
@endsection